'===============================================================================
' Copyright 2014 Alachisoft.  All rights reserved.
'===============================================================================



Imports System
Imports System.Runtime.CompilerServices
Imports System.Runtime.InteropServices
Imports System.Globalization
Imports System.Resources
Imports System.Collections
Imports TDevFramework

 Namespace NCacheSample

	Public Interface IOrders
		
	
		Property OrderID() As Int32
		Property CustomerID() As String
		Property EmployeeID() As Int32
		Property OrderDate() As DateTime
		Property RequiredDate() As DateTime
		Property ShippedDate() As DateTime
		Property ShipVia() As Int32
		Property Freight() As Decimal
		Property ShipName() As String
		Property ShipAddress() As String
		Property ShipCity() As String
		Property ShipRegion() As String
		Property ShipPostalCode() As String
		Property ShipCountry() As String
		Property OrderDetails() As OrderDetailsCollection
	End Interface
	
	< ClassInterface(ClassInterfaceType.AutoDual), Serializable()> _
	Public Class Orders 
		        Inherits PersistentObject
				Implements IOrders, IComparable 
	
		Private _OrderDetails As OrderDetailsCollection = Nothing
        Public Sub New()
            SetupFields()
        End Sub

		
		' <summary>
		' Gets or sets the <c>OrderID</c> attribute value.
		' </summary>
		' <value>The <c>OrderID</c> attribute value.</value>
        Public Property OrderID() As Int32 _
            Implements IOrders.OrderID
			Get
                If (Not me("OrderID").Null) Then
                    Return CType(me("OrderID").Value, Int32)
                Else
                    Return New Int32()
                End If

            End Get
            Set(ByVal Value As Int32)
                Me("OrderID").Value = Value
            End Set
        End Property
		
		' <summary>
		' Gets or sets the <c>CustomerID</c> attribute value.
		' </summary>
		' <value>The <c>CustomerID</c> attribute value.</value>
        Public Property CustomerID() As String _
            Implements IOrders.CustomerID
			Get
                If (Not me("CustomerID").Null) Then
                    Return CType(me("CustomerID").Value, String)
                Else
                    Return Nothing
                End If
			End Get
			Set(ByVal Value As String)
				me("CustomerID").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>EmployeeID</c> attribute value.
		' </summary>
		' <value>The <c>EmployeeID</c> attribute value.</value>
        Public Property EmployeeID() As Int32 _
            Implements IOrders.EmployeeID
			Get
                If (Not me("EmployeeID").Null) Then
                    Return CType(me("EmployeeID").Value, Int32)
                Else
                    Return New Int32()
                End If
			End Get
			Set(ByVal Value As Int32)
				me("EmployeeID").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>OrderDate</c> attribute value.
		' </summary>
		' <value>The <c>OrderDate</c> attribute value.</value>
        Public Property OrderDate() As DateTime _
            Implements IOrders.OrderDate
			Get
                If (Not me("OrderDate").Null) Then
                    Return CType(me("OrderDate").Value, DateTime)
                Else
                    Return New DateTime()
                End If
			End Get
			Set(ByVal Value As DateTime)
				me("OrderDate").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>RequiredDate</c> attribute value.
		' </summary>
		' <value>The <c>RequiredDate</c> attribute value.</value>
        Public Property RequiredDate() As DateTime _
            Implements IOrders.RequiredDate
			Get
                If (Not me("RequiredDate").Null) Then
                    Return CType(me("RequiredDate").Value, DateTime)
                Else
                    Return New DateTime()
                End If
			End Get
			Set(ByVal Value As DateTime)
				me("RequiredDate").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>ShippedDate</c> attribute value.
		' </summary>
		' <value>The <c>ShippedDate</c> attribute value.</value>
        Public Property ShippedDate() As DateTime _
            Implements IOrders.ShippedDate
			Get
                If (Not me("ShippedDate").Null) Then
                    Return CType(me("ShippedDate").Value, DateTime)
                Else
                    Return New DateTime()
                End If
			End Get
			Set(ByVal Value As DateTime)
				me("ShippedDate").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>ShipVia</c> attribute value.
		' </summary>
		' <value>The <c>ShipVia</c> attribute value.</value>
        Public Property ShipVia() As Int32 _
            Implements IOrders.ShipVia
			Get
                If (Not me("ShipVia").Null) Then
                    Return CType(me("ShipVia").Value, Int32)
                Else
                    Return New Int32()
                End If
			End Get
			Set(ByVal Value As Int32)
				me("ShipVia").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>Freight</c> attribute value.
		' </summary>
		' <value>The <c>Freight</c> attribute value.</value>
        Public Property Freight() As Decimal _
            Implements IOrders.Freight
			Get
                If (Not me("Freight").Null) Then
                    Return CType(me("Freight").Value, Decimal)
                Else
                    Return New Decimal()
                End If
			End Get
			Set(ByVal Value As Decimal)
				me("Freight").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>ShipName</c> attribute value.
		' </summary>
		' <value>The <c>ShipName</c> attribute value.</value>
        Public Property ShipName() As String _
            Implements IOrders.ShipName
			Get
                If (Not me("ShipName").Null) Then
                    Return CType(me("ShipName").Value, String)
                Else
                    Return Nothing
                End If
			End Get
			Set(ByVal Value As String)
				me("ShipName").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>ShipAddress</c> attribute value.
		' </summary>
		' <value>The <c>ShipAddress</c> attribute value.</value>
        Public Property ShipAddress() As String _
            Implements IOrders.ShipAddress
			Get
                If (Not me("ShipAddress").Null) Then
                    Return CType(me("ShipAddress").Value, String)
                Else
                    Return Nothing
                End If
			End Get
			Set(ByVal Value As String)
				me("ShipAddress").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>ShipCity</c> attribute value.
		' </summary>
		' <value>The <c>ShipCity</c> attribute value.</value>
        Public Property ShipCity() As String _
            Implements IOrders.ShipCity
			Get
                If (Not me("ShipCity").Null) Then
                    Return CType(me("ShipCity").Value, String)
                Else
                    Return Nothing
                End If
			End Get
			Set(ByVal Value As String)
				me("ShipCity").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>ShipRegion</c> attribute value.
		' </summary>
		' <value>The <c>ShipRegion</c> attribute value.</value>
        Public Property ShipRegion() As String _
            Implements IOrders.ShipRegion
			Get
                If (Not me("ShipRegion").Null) Then
                    Return CType(me("ShipRegion").Value, String)
                Else
                    Return Nothing
                End If
			End Get
			Set(ByVal Value As String)
				me("ShipRegion").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>ShipPostalCode</c> attribute value.
		' </summary>
		' <value>The <c>ShipPostalCode</c> attribute value.</value>
        Public Property ShipPostalCode() As String _
            Implements IOrders.ShipPostalCode
			Get
                If (Not me("ShipPostalCode").Null) Then
                    Return CType(me("ShipPostalCode").Value, String)
                Else
                    Return Nothing
                End If
			End Get
			Set(ByVal Value As String)
				me("ShipPostalCode").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>ShipCountry</c> attribute value.
		' </summary>
		' <value>The <c>ShipCountry</c> attribute value.</value>
        Public Property ShipCountry() As String _
            Implements IOrders.ShipCountry
			Get
                If (Not me("ShipCountry").Null) Then
                    Return CType(me("ShipCountry").Value, String)
                Else
                    Return Nothing
                End If
			End Get
			Set(ByVal Value As String)
				me("ShipCountry").Value = Value
			End Set
		End Property
	
		' <summary>
		' Gets or sets the collection of <c>OrderDetails</c> objects.
		' </summary>
		' <value>The <c>OrderDetailsCollection</c> object.</value>
        Public Property OrderDetails() As OrderDetailsCollection _
            Implements IOrders.OrderDetails
			Get
				Return _OrderDetails
			End Get
			Set(ByVal Value As OrderDetailsCollection)
				_OrderDetails = Value
			End Set
		End Property		
	
		Public  Function  SetNull(ByVal szFieldName As String ,ByVal bNull As Boolean)
			me(szFieldName).Null = bNull
		End Function

		Public  Function  IsNull(ByVal szFieldName As String) As Boolean
			Return me(szFieldName).Null
		End Function

        Public Overloads Function CompareTo(ByVal obj As Object) As Integer Implements IComparable.CompareTo
            Try

                If TypeOf obj Is Orders Then
                    Dim cmpOrders As Orders = CType(obj, Orders)

                    If OrderID.CompareTo(cmpOrders.OrderID) = 0  Then
                        Return 1
                    Else
                        Return 0
                    End If
                End If
            Catch ex As Exception
                Throw New ArgumentException("object is not an instance of Orders")
            End Try

        End Function
        Private Function SetupFields()

            AddField(New PersistentField("OrderID", True, True, TDevFramework.EDataType.eInt))
            AddField(New PersistentField("CustomerID", False, False, TDevFramework.EDataType.eVarchar))
            AddField(New PersistentField("EmployeeID", False, False, TDevFramework.EDataType.eInt))
            AddField(New PersistentField("OrderDate", False, False, TDevFramework.EDataType.eDateTime))
            AddField(New PersistentField("RequiredDate", False, False, TDevFramework.EDataType.eDateTime))
            AddField(New PersistentField("ShippedDate", False, False, TDevFramework.EDataType.eDateTime))
            AddField(New PersistentField("ShipVia", False, False, TDevFramework.EDataType.eInt))
            AddField(New PersistentField("Freight", False, False, TDevFramework.EDataType.eDecimal))
            AddField(New PersistentField("ShipName", False, False, TDevFramework.EDataType.eVarchar))
            AddField(New PersistentField("ShipAddress", False, False, TDevFramework.EDataType.eVarchar))
            AddField(New PersistentField("ShipCity", False, False, TDevFramework.EDataType.eVarchar))
            AddField(New PersistentField("ShipRegion", False, False, TDevFramework.EDataType.eVarchar))
            AddField(New PersistentField("ShipPostalCode", False, False, TDevFramework.EDataType.eVarchar))
            AddField(New PersistentField("ShipCountry", False, False, TDevFramework.EDataType.eVarchar))
        End Function

        Public Sub Copy(ByVal objInfo As Orders)
            Me.OrderID = objInfo.OrderID
            Me.CustomerID = objInfo.CustomerID
            Me.EmployeeID = objInfo.EmployeeID
            Me.OrderDate = objInfo.OrderDate
            Me.RequiredDate = objInfo.RequiredDate
            Me.ShippedDate = objInfo.ShippedDate
            Me.ShipVia = objInfo.ShipVia
            Me.Freight = objInfo.Freight
            Me.ShipName = objInfo.ShipName
            Me.ShipAddress = objInfo.ShipAddress
            Me.ShipCity = objInfo.ShipCity
            Me.ShipRegion = objInfo.ShipRegion
            Me.ShipPostalCode = objInfo.ShipPostalCode
            Me.ShipCountry = objInfo.ShipCountry
            'Me.Dirty = objInfo.Dirty
            'Me.IsNew = objInfo.IsNew
        End Sub
    End Class
End Namespace