'===============================================================================
' Copyright 2014 Alachisoft.  All rights reserved.
'===============================================================================



Imports System
Imports System.Data
Imports System.Collections
Imports System.Runtime.CompilerServices
Imports System.Runtime.InteropServices
Imports TDevFramework

 Namespace NCacheSample

    Public Interface IOrdersCollection
        Property item(ByVal index As Integer) As Orders
        Sub Add(ByRef objValue As Orders)
        Sub Remove(ByRef objValue As Orders)
        Function Contains(ByRef objValue As Orders) As Boolean
        Function IsContain(ByVal value As Orders) As Int64
    End Interface


    <ClassInterface(ClassInterfaceType.AutoDual), Serializable()> _
    Public Class OrdersCollection
        Inherits Collection
        Implements IOrdersCollection
        Public Sub New()
            '--
        End Sub

        ' <summary>
        ' Gets the <c>Orders</c> object at the specified index.
        ' </summary>
        ' <value>The <c>Orders</c> object.</value>
        Default Public Shadows Property item(ByVal index As Integer) As Orders _
            Implements IOrdersCollection.item
            Get
                Return CType(MyBase.Item(index), Orders)
            End Get
            Set(ByVal Value As Orders)
                MyBase.Item(index) = Value
            End Set

        End Property

        Public Overloads Sub Add(ByRef value As Orders) _
            Implements IOrdersCollection.Add

            MyBase.Add(value)
        End Sub

        Public Overloads Sub Remove(ByRef value As Orders) _
            Implements IOrdersCollection.Remove

            MyBase.Remove(value)
        End Sub

        ' <summary>
        ' If value is not of type object, this will return false.
        ' </summary>
        Public Overloads Function Contains(ByRef value As Orders) As Boolean _
            Implements IOrdersCollection.Contains

            Return MyBase.Contains(value)
        End Function

        Public Function IsContain(ByVal value As Orders) As Int64 _
            Implements IOrdersCollection.IsContain
            Dim _order As Orders
            Dim index As Int32 = 0

            For Each _order In List

                If _order.CompareTo(value) = 0 Then
                    Return index
                End If

                index = index + 1
            Next

            Return -1
        End Function

    End Class
End Namespace