'===============================================================================
' Copyright 2014 Alachisoft.  All rights reserved.
'===============================================================================



Imports System
Imports System.Runtime.CompilerServices
Imports System.Runtime.InteropServices
Imports System.Globalization
Imports System.Resources
Imports System.Collections
Imports TDevFramework

 Namespace NCacheSample

	Public Interface IProducts
		
	
		Property ProductID() As Int32
		Property ProductName() As String
		Property SupplierID() As Int32
		Property CategoryID() As Int32
		Property QuantityPerUnit() As String
		Property UnitPrice() As Decimal
		Property UnitsInStock() As Int16
		Property UnitsOnOrder() As Int16
		Property ReorderLevel() As Int16
		Property Discontinued() As Boolean
	End Interface
	
	< ClassInterface(ClassInterfaceType.AutoDual), Serializable()> _
	Public Class Products 
		        Inherits PersistentObject
				Implements IProducts, IComparable 
	
        Public Sub New()
            SetupFields()
        End Sub

		
		' <summary>
		' Gets or sets the <c>ProductID</c> attribute value.
		' </summary>
		' <value>The <c>ProductID</c> attribute value.</value>
        Public Property ProductID() As Int32 _
            Implements IProducts.ProductID
			Get
                If (Not me("ProductID").Null) Then
                    Return CType(me("ProductID").Value, Int32)
                Else
                    Return New Int32()
                End If
			End Get
			Set(ByVal Value As Int32)
				me("ProductID").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>ProductName</c> attribute value.
		' </summary>
		' <value>The <c>ProductName</c> attribute value.</value>
        Public Property ProductName() As String _
            Implements IProducts.ProductName
			Get
                If (Not me("ProductName").Null) Then
                    Return CType(me("ProductName").Value, String)
                Else
                    Return Nothing
                End If
			End Get
			Set(ByVal Value As String)
				me("ProductName").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>SupplierID</c> attribute value.
		' </summary>
		' <value>The <c>SupplierID</c> attribute value.</value>
        Public Property SupplierID() As Int32 _
            Implements IProducts.SupplierID
			Get
                If (Not me("SupplierID").Null) Then
                    Return CType(me("SupplierID").Value, Int32)
                Else
                    Return New Int32()
                End If
			End Get
			Set(ByVal Value As Int32)
				me("SupplierID").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>CategoryID</c> attribute value.
		' </summary>
		' <value>The <c>CategoryID</c> attribute value.</value>
        Public Property CategoryID() As Int32 _
            Implements IProducts.CategoryID
			Get
                If (Not me("CategoryID").Null) Then
                    Return CType(me("CategoryID").Value, Int32)
                Else
                    Return New Int32()
                End If
			End Get
			Set(ByVal Value As Int32)
				me("CategoryID").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>QuantityPerUnit</c> attribute value.
		' </summary>
		' <value>The <c>QuantityPerUnit</c> attribute value.</value>
        Public Property QuantityPerUnit() As String _
            Implements IProducts.QuantityPerUnit
			Get
                If (Not me("QuantityPerUnit").Null) Then
                    Return CType(me("QuantityPerUnit").Value, String)
                Else
                    Return Nothing
                End If
			End Get
			Set(ByVal Value As String)
				me("QuantityPerUnit").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>UnitPrice</c> attribute value.
		' </summary>
		' <value>The <c>UnitPrice</c> attribute value.</value>
        Public Property UnitPrice() As Decimal _
            Implements IProducts.UnitPrice
			Get
                If (Not me("UnitPrice").Null) Then
                    Return CType(me("UnitPrice").Value, Decimal)
                Else
                    Return New Decimal()
                End If
			End Get
			Set(ByVal Value As Decimal)
				me("UnitPrice").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>UnitsInStock</c> attribute value.
		' </summary>
		' <value>The <c>UnitsInStock</c> attribute value.</value>
        Public Property UnitsInStock() As Int16 _
            Implements IProducts.UnitsInStock
			Get
                If (Not me("UnitsInStock").Null) Then
                    Return CType(me("UnitsInStock").Value, Int16)
                Else
                    Return New Int16()
                End If
			End Get
			Set(ByVal Value As Int16)
				me("UnitsInStock").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>UnitsOnOrder</c> attribute value.
		' </summary>
		' <value>The <c>UnitsOnOrder</c> attribute value.</value>
        Public Property UnitsOnOrder() As Int16 _
            Implements IProducts.UnitsOnOrder
			Get
                If (Not me("UnitsOnOrder").Null) Then
                    Return CType(me("UnitsOnOrder").Value, Int16)
                Else
                    Return New Int16()
                End If
			End Get
			Set(ByVal Value As Int16)
				me("UnitsOnOrder").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>ReorderLevel</c> attribute value.
		' </summary>
		' <value>The <c>ReorderLevel</c> attribute value.</value>
        Public Property ReorderLevel() As Int16 _
            Implements IProducts.ReorderLevel
			Get
                If (Not me("ReorderLevel").Null) Then
                    Return CType(me("ReorderLevel").Value, Int16)
                Else
                    Return New Int16()
                End If
			End Get
			Set(ByVal Value As Int16)
				me("ReorderLevel").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>Discontinued</c> attribute value.
		' </summary>
		' <value>The <c>Discontinued</c> attribute value.</value>
        Public Property Discontinued() As Boolean _
            Implements IProducts.Discontinued
			Get
                If (Not me("Discontinued").Null) Then
                    Return CType(me("Discontinued").Value, Boolean)
                Else
                    Return New Boolean()
                End If
			End Get
			Set(ByVal Value As Boolean)
				me("Discontinued").Value = Value
			End Set
		End Property
		Public  Function  SetNull(ByVal szFieldName As String ,ByVal bNull As Boolean)
			me(szFieldName).Null = bNull
		End Function

		Public  Function  IsNull(ByVal szFieldName As String) As Boolean
			Return me(szFieldName).Null
		End Function

        Public Overloads Function CompareTo(ByVal obj As Object) As Integer Implements IComparable.CompareTo
            Try
                If TypeOf obj Is Products Then
                    Dim cmpProducts As Products = CType(obj, Products)
                    If ProductID.CompareTo(cmpProducts.ProductID) = 0 Then
                        Return 1
                    Else
                        Return 0
                    End If
                End If
            Catch ex As Exception
                Throw New ArgumentException("object is not an instance of Products")
            End Try
            
        End Function
        Private Function SetupFields()

            AddField(New PersistentField("ProductID", True, True, TDevFramework.EDataType.eInt))
            AddField(New PersistentField("ProductName", True, False, TDevFramework.EDataType.eVarchar))
            AddField(New PersistentField("SupplierID", False, False, TDevFramework.EDataType.eInt))
            AddField(New PersistentField("CategoryID", False, False, TDevFramework.EDataType.eInt))
            AddField(New PersistentField("QuantityPerUnit", False, False, TDevFramework.EDataType.eVarchar))
            AddField(New PersistentField("UnitPrice", False, False, TDevFramework.EDataType.eDecimal))
            AddField(New PersistentField("UnitsInStock", False, False, TDevFramework.EDataType.eSmallInt))
            AddField(New PersistentField("UnitsOnOrder", False, False, TDevFramework.EDataType.eSmallInt))
            AddField(New PersistentField("ReorderLevel", False, False, TDevFramework.EDataType.eSmallInt))
            AddField(New PersistentField("Discontinued", True, False, TDevFramework.EDataType.eBoolean))
        End Function

        Public Sub Copy(ByVal objInfo As Products)
            Me.ProductID = objInfo.ProductID
            Me.ProductName = objInfo.ProductName
            Me.SupplierID = objInfo.SupplierID
            Me.CategoryID = objInfo.CategoryID
            Me.QuantityPerUnit = objInfo.QuantityPerUnit
            Me.UnitPrice = objInfo.UnitPrice
            Me.UnitsInStock = objInfo.UnitsInStock
            Me.UnitsOnOrder = objInfo.UnitsOnOrder
            Me.ReorderLevel = objInfo.ReorderLevel
            Me.Discontinued = objInfo.Discontinued
            'Me.Dirty = objInfo.Dirty
            'Me.IsNew = objInfo.IsNew
        End Sub
    End Class
End Namespace