'===============================================================================
' Copyright 2014 Alachisoft.  All rights reserved.
'===============================================================================


' <fileinfo name="OrdersFactory.vb">
'		<author></author>
'		<creation-datetime>Tue Jun 07 04:35:01 2005</creation-datetime>
'		<description>
'			Contains VB.NET code OrdersFactory.
'		</description>
'		<remarks>
'			Changes to this file will be lost if the code is regenerated.
'		</remarks>
' </fileinfo>
 
Imports System
Imports System.Data
Imports System.Text
Imports System.Globalization
Imports System.Resources
Imports System.Threading
Imports System.Reflection
Imports System.Collections
Imports System.Runtime.CompilerServices
Imports System.Runtime.InteropServices
Imports TDevFramework 

Imports System.Data.OleDb

 Namespace NCacheSample

	Public Interface IOrdersFactory
        Function Load(ByRef objInfo As Orders, ByVal nDepth As Int32, ByVal bCacheEnalbed As Boolean)
        Function Insert(ByRef objInfo As Orders, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean)
        Function Update(ByRef objInfo As Orders, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean)
        Function Delete(ByRef objInfo As Orders, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean)
        'Function Save(ByRef objList As OrdersCollection, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean, ByVal strCacheKey As String)
        Function DeleteColl(ByRef objList As OrdersCollection, ByVal nDepth As Int32)
        'Function ProcessDataSet(ByVal dataSet As DataSet)

        Function FindByCustomers(ByVal strprmCustomerID As String, ByVal bCacheEnabled As Boolean) As OrdersCollection
        Function FindByCustomersCount(ByVal strprmCustomerID As String) As Int32
        Function FindByCustomersPR(ByVal nSP As Int32, ByVal nRecords As Int32, ByVal strprmCustomerID As String) As OrdersCollection
        Function getCustomerOrders(ByVal strprm1 As String, ByVal bCacheEnabled As Boolean) As OrdersCollection
        Function getCustomerOrdersCount(ByVal strprm1 As String) As Int32
        Function DeleteByCustomers(ByVal strprmCustomerID As String) As Integer
    End Interface


    ''' <summary>
    ''' Object <c>Orders</c>Factory. Provides implementation.
    ''' </summary>
    ''' <remarks>
    '''		
    ''' </remarks>
    <ClassInterface(ClassInterfaceType.AutoDual)> _
        Public Class OrdersFactory
        Inherits DbObject
        Implements IOrdersFactory
        ' define constants here for either dynamic SQL or stored procedure calls

        Private Shared _stQryObject As String
        Private Shared _stPKQryObject As String
        Private Shared _stRelObject As String
        Private Const _stObjectName As String = "Orders"
        Private Const USE_STORE_PROC As Boolean = False
        Private Const STD_LOAD_SQL As String = _
            "SELECT" & _
            "     a18.[OrderID] as OrderID, a18.[CustomerID] as CustomerID," & _
            "     a18.[EmployeeID] as EmployeeID, a18.[OrderDate] as OrderDate," & _
            "     a18.[RequiredDate] as RequiredDate, a18.[ShippedDate] as ShippedDate," & _
            "     a18.[ShipVia] as ShipVia, a18.[Freight] as Freight," & _
            "     a18.[ShipName] as ShipName, a18.[ShipAddress] as ShipAddress," & _
            "     a18.[ShipCity] as ShipCity, a18.[ShipRegion] as ShipRegion," & _
            "     a18.[ShipPostalCode] as ShipPostalCode, a18.[ShipCountry] as ShipCountry" & _
            " FROM" & _
            "     [Orders] a18" & _
            " WHERE" & _
            "     [OrderID] = ?"
        Private Const STD_INSERT_SQL As String = _
            "INSERT INTO [Orders]" & _
            "    ([CustomerID], [EmployeeID]" & _
            "     , [OrderDate], [RequiredDate]" & _
            "     , [ShippedDate], [ShipVia]" & _
            "     , [Freight], [ShipName]" & _
            "     , [ShipAddress], [ShipCity]" & _
            "     , [ShipRegion], [ShipPostalCode]" & _
            "     , [ShipCountry]) VALUES (?, ?" & _
            "     , ?, ?" & _
            "     , ?, ?" & _
            "     , ?, ?" & _
            "     , ?, ?" & _
            "     , ?, ?" & _
            "     , ?)"
        Private Const STD_DELETE_SQL As String = _
            "DELETE FROM [Orders] WHERE [OrderID] = ?"
        Private Const STD_UPDATE_SQL As String = _
            "UPDATE" & _
            "     [Orders]" & _
            " SET" & _
            "     [CustomerID] = ?, [EmployeeID] = ?," & _
            "     [OrderDate] = ?, [RequiredDate] = ?," & _
            "     [ShippedDate] = ?, [ShipVia] = ?," & _
            "     [Freight] = ?, [ShipName] = ?," & _
            "     [ShipAddress] = ?, [ShipCity] = ?," & _
            "     [ShipRegion] = ?, [ShipPostalCode] = ?," & _
            "     [ShipCountry] = ?" & _
            " WHERE" & _
            "     [OrderID] = ?"
        Private Const FindByCustomers_SQL As String = _
            "SELECT" & _
            "     a18.[OrderID] as OrderID, a18.[CustomerID] as CustomerID," & _
            "     a18.[EmployeeID] as EmployeeID, a18.[OrderDate] as OrderDate," & _
            "     a18.[RequiredDate] as RequiredDate, a18.[ShippedDate] as ShippedDate," & _
            "     a18.[ShipVia] as ShipVia, a18.[Freight] as Freight," & _
            "     a18.[ShipName] as ShipName, a18.[ShipAddress] as ShipAddress," & _
            "     a18.[ShipCity] as ShipCity, a18.[ShipRegion] as ShipRegion," & _
            "     a18.[ShipPostalCode] as ShipPostalCode, a18.[ShipCountry] as ShipCountry" & _
            " FROM" & _
            "     [Orders] a18" & _
            " WHERE" & _
            "     (a18.[CustomerID] = ?)"

        Private Const FindByCustomersCount_SQL As String = _
            "SELECT" & _
            "    COUNT(*)" & _
            " FROM" & _
            "     [Orders] a18" & _
            " WHERE" & _
            "     (a18.[CustomerID] = ?)"
        Private Const getCustomerOrders_SQL As String = _
            "SELECT" & _
            "     a18.[OrderID] as OrderID, a18.[CustomerID] as CustomerID," & _
            "     a18.[EmployeeID] as EmployeeID, a18.[OrderDate] as OrderDate," & _
            "     a18.[RequiredDate] as RequiredDate, a18.[ShippedDate] as ShippedDate," & _
            "     a18.[ShipVia] as ShipVia, a18.[Freight] as Freight," & _
            "     a18.[ShipName] as ShipName, a18.[ShipAddress] as ShipAddress," & _
            "     a18.[ShipCity] as ShipCity, a18.[ShipRegion] as ShipRegion," & _
            "     a18.[ShipPostalCode] as ShipPostalCode, a18.[ShipCountry] as ShipCountry" & _
            " FROM" & _
            "     [Orders] a18" & _
            " WHERE (a18.[CustomerID] = ?)" & _
            " ORDER BY a18.OrderDate Desc "

        Private Const getCustomerOrdersCount_SQL As String = _
            "SELECT" & _
            "    COUNT(*)" & _
            " FROM" & _
            "     [Orders] a18" & _
            " where (a18.[customerid] = ?)"
        Private Const DeleteByCustomers_SQL As String = _
            "DELETE FROM" & _
            "     [Orders]" & _
            " WHERE ([CustomerID] = ?)"



        ' second argument to base() is a flag about whether we're using stored procedures
        ' or dynamic SQL; true = storedProc, false = dynamic sql
        'TDevFramework.PropertyFile.CreateInstance("DbConnStr.db").LoadProperty("Orders")
        Public Sub New()
            MyBase.new("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=..\..\NorthwindDB\Northwind.mdb;User Id=;Password=;", TDevFramework.EDBProvider.OLEDB)
        End Sub

        Public Sub New(ByVal connectionString As String)
            MyBase.new(connectionString, TDevFramework.EDBProvider.OLEDB)
        End Sub

        Public Sub New(ByVal connection As TDevFramework.Connection)
            MyBase.new(connection)
        End Sub

        Public Sub New(ByVal connection As Object)
            MyBase.new(connection, TDevFramework.EDBProvider.OLEDB)
        End Sub

#Region "[Cache Keys]"

        Private Function GetPKQueryKey() As String
            Dim key As String

            key = Convert.ToString(Me) + ".PKQry" ' A dummy key ...

            If _stPKQryObject = "" Then
                _stPKQryObject = "INSTANTIATED"
                NCacheUtil.Store(key, _stPKQryObject, Nothing)
            End If

            GetPKQueryKey = key
        End Function
        Private Function GetQueryKey() As String

            Dim key As String

            key = Convert.ToString(Me) + ".NonPKQry" ' A dummy key ...

            If _stQryObject = "" Then
                _stQryObject = "INSTANTIATED"
                NCacheUtil.Store(key, _stQryObject, Nothing)
            End If

            GetQueryKey = key
        End Function

        Private Function GetRelatedKey() As String

            Dim key As String

            key = Convert.ToString(Me) + ".Rel" ' A dummy key

            If _stRelObject Is Nothing Then
                _stRelObject = "INSTANTIATED"
                NCacheUtil.Store(key, _stRelObject, Nothing)
            End If

            GetRelatedKey = key
        End Function

        Private Sub InvalidateAll()

            NCacheUtil.Remove(GetQueryKey()) '
            NCacheUtil.Remove(GetPKQueryKey()) '
            NCacheUtil.Remove(GetRelatedKey()) '
            _stRelObject = Nothing '
            _stQryObject = Nothing

        End Sub
        Private Sub Invalidate(ByVal type As NCacheUtil.InvalidateType, ByVal ParamArray relatedKeys As String())
            '_staticObject = "INVALIDATED"
            'NCacheUtil.Insert(GetStaticObjectKey(),_staticObject,Nothing)
            '_staticObject = Nothing'
            If ((type And NCacheUtil.InvalidateType.QueryCollectionPK) = NCacheUtil.InvalidateType.QueryCollectionPK) Then

                If _stPKQryObject <> "" Then
                    NCacheUtil.Remove(GetPKQueryKey())
                    _stPKQryObject = Nothing
                End If

            End If

            If ((type And NCacheUtil.InvalidateType.QueryCollection) = NCacheUtil.InvalidateType.QueryCollection) Then

                If _stQryObject <> "" Then
                    NCacheUtil.Remove(GetQueryKey())
                    _stQryObject = Nothing
                End If

            End If

            If ((type And NCacheUtil.InvalidateType.RelatedCollection) = NCacheUtil.InvalidateType.RelatedCollection) Then

                NCacheUtil.Remove(relatedKeys)
                _stRelObject = Nothing

            End If

        End Sub

        Private Function GetRelatedKeys(ByVal objInfo As Object) As String()
            Dim keys(0) As String

            keys(0) = NCacheUtil.GetRelationKey("Customers", "Orders", objInfo.CustomerID.ToString())

            GetRelatedKeys = keys
        End Function
#End Region

#Region "[Cache Operations]"
        ' <summary>
        ' 	InsertCustomerCache (Cache Operation)
        ' </summary>
        ' <remarks>
        ' 	Updates the related collection (Parent-Child) in Cache with the new object.
        ' </remarks>
        ' <param name="objInfo">The <c>Orders</c> info object containing the primary key.</param>

        Private Function InsertCustomerCache(ByRef objInfo As Orders)

            'Dim objKey As String
            Dim _orderColl As OrdersCollection
            Dim _order As Orders
            Dim cacheKeys As ArrayList
            Dim ColKey As String

            'objKey = NCacheUtil.GetObjectKey(_stObjectName, objInfo.OrderID.ToString()) ' Get the object key...
            ColKey = NCacheUtil.GetRelationKey("Customers", "Orders", objInfo.CustomerID.ToString())

            _orderColl = NCacheUtil.Load(ColKey)
            'NCacheUtil.Store(objKey, objInfo, Nothing, DateTime.Now.AddMinutes(30)) ' Store the new object into cache...

            If Not _orderColl Is Nothing Then
                Dim index As Int32

                index = _orderColl.IsContain(objInfo)
                If index < 0 Then
                    _orderColl.Add(objInfo)
                End If

                cacheKeys = New ArrayList
                For Each _order In _orderColl
                    cacheKeys.Add(NCacheUtil.GetObjectKey(_stObjectName, _order.OrderID.ToString()))
                Next

                If cacheKeys.Count > 0 Then
                    cacheKeys.Add(GetRelatedKey())
                    NCacheUtil.Insert(ColKey, _orderColl, cacheKeys, DateTime.Now.AddMinutes(30))
                End If

            End If

            'Invalidate(NCacheUtil.InvalidateType.QueryCollectionPK Or NCacheUtil.InvalidateType.QueryCollection, Nothing)

        End Function
        ' <summary>
        ' 	DeleteCustomerCache (Cache Operation)
        ' </summary>
        ' <remarks>
        ' 	Deletes an object from the related collection (Parent-Child) in Cache.
        ' </remarks>
        ' <param name="objInfo">The <c>Orders</c> info object containing the primary key.</param>
        Private Function DeleteCustomerCache(ByRef objInfo As Orders)

            'Dim objKey As String
            Dim _orderColl As OrdersCollection
            Dim _order As Orders
            Dim cacheKeys As ArrayList
            Dim ColKey As String

            'objKey = NCacheUtil.GetObjectKey(_stObjectName, objInfo.OrderID.ToString())
            ColKey = NCacheUtil.GetRelationKey("Customers", "Orders", objInfo.CustomerID.ToString())

            _orderColl = NCacheUtil.Load(ColKey)
            cacheKeys = New ArrayList

            If Not _orderColl Is Nothing Then
                ' Looking for the collection
                Dim index As Int32

                index = _orderColl.IsContain(objInfo)

                If index >= 0 Then

                    _orderColl.RemoveAt(index)
                    '_orderColl.MarkedDeletedItems.RemoveAt(_orderColl.MarkedDeletedItems.Count)
                    _orderColl.MarkedDeletedItems.Clear()

                End If

                For Each _order In _orderColl
                    cacheKeys.Add(NCacheUtil.GetObjectKey(_stObjectName, _order.OrderID.ToString()))
                Next
            End If

            'NCacheUtil.Remove(objKey)  ' Invalidating RElated Collection PKQueryCollection...
            If cacheKeys.Count > 0 Then

                cacheKeys.Add(GetRelatedKey())
                NCacheUtil.Insert(ColKey, _orderColl, cacheKeys, DateTime.Now.AddMinutes(30))

            End If

            'NCacheUtil.Remove(objKey)
            'Invalidate(NCacheUtil.InvalidateType.QueryCollectionPK Or NCacheUtil.InvalidateType.QueryCollection, Nothing) ' Invalidating Collection With NO PK and PK

        End Function
        ' <summary>
        ' 	UpdateCustomerCache (Cache Operation)
        ' </summary>
        ' <remarks>
        ' 	Updates an object in the related collection (Parent-Child) in Cache.
        ' </remarks>
        ' <param name="objInfo">The <c>Orders</c> info object containing the primary key.</param>
        Private Function UpdateCustomerCache(ByRef objInfo As Orders)

            'Dim objKey As String
            Dim _orderColl As OrdersCollection
            Dim _order As Orders
            Dim cacheKeys As ArrayList
            Dim ColKey As String

            'objKey = NCacheUtil.GetObjectKey(_stObjectName, objInfo.OrderID.ToString())
            ColKey = NCacheUtil.GetRelationKey("Customers", "Orders", objInfo.CustomerID.ToString())

            _orderColl = NCacheUtil.Load(ColKey)
            cacheKeys = New ArrayList

            If Not _orderColl Is Nothing Then ' If found....

                Dim index As Int32
                index = _orderColl.IsContain(objInfo) ' if the object exist...
                Dim obj As Orders = New Orders

                If Not index < 0 Then
                    _orderColl.item(index).Copy(objInfo)

                    For Each _order In _orderColl
                        cacheKeys.Add(NCacheUtil.GetObjectKey(_stObjectName, _order.OrderID.ToString()))
                    Next

                End If

            End If

            'NCacheUtil.Remove(objKey)  ' Invalidating RElated Collection PKQueryCollection...
            If cacheKeys.Count > 0 Then

                cacheKeys.Add(GetRelatedKey())
                NCacheUtil.Insert(ColKey, _orderColl, cacheKeys, DateTime.Now.AddMinutes(30))

            End If

            'NCacheUtil.Insert(objKey, objInfo, Nothing, DateTime.Now.AddMinutes(30))
            ' Invalidate(NCacheUtil.InvalidateType.QueryCollectionPK Or NCacheUtil.InvalidateType.QueryCollection, Nothing) ' Invalidating Collection With NO PK and PK
            ' adding the copy of this object in Cache.. 
        End Function
#End Region

#Region " Standard Methods "


        ' <summary>
        ' 	Load (Standard Load Method [Cache Enabled])
        ' </summary>
        ' <remarks>
        ' 	Loads a record from the <c>[Orders]</c> table given by
        ' 	the specified primary key.
        ' </remarks>
        ' <param name="objInfo">The <c>Orders</c> info object containing the primary key.</param>
        ' <param name="nDepth">Specifies depth of children should be loaded.</param>
        Public Function Load(ByRef objInfo As Orders, ByVal nDepth As Integer, ByVal bCacheEnable As Boolean) _
        Implements IOrdersFactory.Load

            Dim objKey As String
            Dim obj As Object
            objKey = NCacheUtil.GetObjectKey(_stObjectName, objInfo.OrderID.ToString())
            Try
                If bCacheEnable Then
                    obj = NCacheUtil.Load(objKey) ' Check if the object is in Cache. 
                    If obj Is Nothing Then ' Cache miss..
                        _Load(objInfo, nDepth, bCacheEnable)
                        Stats.ObjsReadFromDB = 1
                        Stats.ReadTripsToDB = 1
                        NCacheUtil.Store(objKey, objInfo, Nothing, DateTime.Now.AddMinutes(30))
                        Exit Function
                    End If
                    Stats.ObjsReadFromCache = 1

                    Dim objTemp As Orders = CType(obj, Orders)
                    objInfo.Copy(objTemp) ' Cache hit..

                    If nDepth <> 0 Then
                        LoadChildren(objInfo, nDepth - 1, bCacheEnable)
                    End If
                Else
                    _Load(objInfo, nDepth, bCacheEnable)
                    Stats.ObjsReadFromDB = 1
                    Stats.ReadTripsToDB = 1
                    If bCacheEnable Then
                        Stats.ObjsReadFromDBWithCache = 1
                        Stats.ReadTripsToDBWithCache = 1
                    End If
                    NCacheUtil.Store(objKey, objInfo, Nothing, DateTime.Now.AddMinutes(30))
                End If
            Catch e As Exception
                Throw e
            End Try
        End Function

        ' <summary>
        ' 	Load (Standard Load Method)
        ' </summary>
        ' <remarks>
        ' 	Loads a record from the <c>[Orders]</c> table given by
        ' 	the specified primary key.
        ' </remarks>
        ' <param name="objInfo">The <c>Orders</c> info object containing the primary key.</param>
        ' <param name="nDepth">Specifies depth of children should be loaded.</param>


        Private Function _Load(ByRef objInfo As Orders, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean)

            Try
                Dim bRecordsFound As Boolean = False
                CheckPrimaryKeyValues(objInfo)
                Prepare(STD_LOAD_SQL, USE_STORE_PROC)

                AddCmdParameter("@OrderID", TDevFramework.EDataType.eInt, objInfo.OrderID, TDevFramework.EParamDirection.eInput, objInfo.IsNull("OrderID"))
                ExecuteReader()
                While (Read())
                    FillPersistentObject(objInfo)
                    objInfo.IsNew = False
                    objInfo.Dirty = False
                    bRecordsFound = True
                End While
                ReleaseReader()
                If Not bRecordsFound Then
                    Throw New RecordNotFoundException("No record found against given search criteria.")
                End If

                If (nDepth <> 0) Then
                    LoadChildren(objInfo, nDepth - 1, bCacheEnable)
                End If

                SetStatus(EStatus.eSuccess)
                ReleaseCommand()

            Catch e As RecordNotFoundException
                SetStatus(EStatus.eSuccess)
                ReleaseCommand()
                Throw e
            Catch e As Exception
                SetStatus(EStatus.eFail)
                ReleaseCommand()
                Throw e
            End Try
        End Function


        ' <summary>
        ' 	Insert (Standard Insert Method)
        ' </summary>
        ' <remarks>
        ' 	Adds a new record into the <c>[Orders]</c> table.
        ' </remarks>
        ' <param name="objInfo">The <c>Orders</c> info object to be inserted.</param>
        ' <param name="nDepth">Specifies depth of children should be inserted.</param>

        Public Function Insert(ByRef objInfo As Orders, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean) _
         Implements IOrdersFactory.Insert
            Try

                objInfo.ValidateRequiredFields()

                Prepare(STD_INSERT_SQL, USE_STORE_PROC)
                If (nDepth <> 0) Then
                End If
                'Read the persistent object
                ReadPersistentObject(objInfo)
                ExecuteNonQuery()

                Prepare("SELECT @@IDENTITY AS OrderID;", False)
                ExecuteReader()

                If (Read()) Then
                    If (Not IsNull("OrderID")) Then
                        objInfo.OrderID = Convert.ToInt32(getValue("OrderID"))
                    End If
                End If
                ReleaseReader()

                If (nDepth <> 0) Then
                    'Repopulate parent id in child list
                    Dim OrderDetailsOrderDetailsInfo As OrderDetails
                    For Each OrderDetailsOrderDetailsInfo In objInfo.OrderDetails
                        OrderDetailsOrderDetailsInfo.OrderID = objInfo.OrderID
                    Next

                    Dim _OrderDetailsFactory As OrderDetailsFactory = New OrderDetailsFactory(getConnection())
                    Dim objParent As Orders = New Orders
                    _OrderDetailsFactory.Save(objInfo.OrderDetails, nDepth - 1, bCacheEnable, objParent)
                End If

                SetStatus(EStatus.eSuccess)
                ReleaseCommand()
                objInfo.IsNew = False
                objInfo.Dirty = False

                Stats.WriteTripsToDB = 1


                If bCacheEnable Then
                    Dim objKey As String

                    objKey = NCacheUtil.GetObjectKey(_stObjectName, objInfo.OrderID.ToString()) ' Get the object key...
                    NCacheUtil.Store(objKey, objInfo, Nothing, DateTime.Now.AddMinutes(30)) ' Store the new object into cache...

                    InsertCustomerCache(objInfo)
                    Invalidate(NCacheUtil.InvalidateType.QueryCollectionPK And NCacheUtil.InvalidateType.QueryCollection, Nothing)
                End If

            Catch e As Exception
                SetStatus(EStatus.eFail)
                ReleaseCommand()
                Throw e
            End Try
        End Function
        Private Function _Insert(ByRef objInfo As Orders, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean)
            Try

                objInfo.ValidateRequiredFields()

                Prepare(STD_INSERT_SQL, USE_STORE_PROC)
                If (nDepth <> 0) Then
                End If
                'Read the persistent object
                ReadPersistentObject(objInfo)
                ExecuteNonQuery()

                Prepare("SELECT @@IDENTITY AS OrderID;", False)
                ExecuteReader()

                If (Read()) Then
                    If (Not IsNull("OrderID")) Then
                        objInfo.OrderID = Convert.ToInt32(getValue("OrderID"))
                    End If
                End If
                ReleaseReader()

                If (nDepth <> 0) Then
                    'Repopulate parent id in child list
                    Dim OrderDetailsOrderDetailsInfo As OrderDetails
                    For Each OrderDetailsOrderDetailsInfo In objInfo.OrderDetails
                        OrderDetailsOrderDetailsInfo.OrderID = objInfo.OrderID
                    Next

                    Dim _OrderDetailsFactory As OrderDetailsFactory = New OrderDetailsFactory(getConnection())
                    Dim objParent As Orders = New Orders
                    _OrderDetailsFactory.Save(objInfo.OrderDetails, nDepth - 1, bCacheEnable, objParent)
                End If

                SetStatus(EStatus.eSuccess)
                ReleaseCommand()
                objInfo.IsNew = False
                objInfo.Dirty = False

                Stats.WriteTripsToDB = 1
                If bCacheEnable Then
                    Dim objKey As String

                    objKey = NCacheUtil.GetObjectKey(_stObjectName, objInfo.OrderID.ToString()) ' Get the object key...
                    NCacheUtil.Store(objKey, objInfo, Nothing, DateTime.Now.AddMinutes(30)) ' Store the new object into cache...
                    Invalidate(NCacheUtil.InvalidateType.QueryCollectionPK And NCacheUtil.InvalidateType.QueryCollection, Nothing)
                End If
            Catch e As Exception
                SetStatus(EStatus.eFail)
                ReleaseCommand()
                Throw e
            End Try
        End Function

        ' <summary>
        ' 	Delete (Standard Delete Method)
        ' </summary>
        ' <remarks>
        ' 	Deletes the record in <c>[Orders]</c> table given
        '   by its primary key.
        ' </remarks>
        ' <param name="objInfo">The <c>Orders</c> info object used to delete the record.</param>
        ' <param name="nDepth">Specifies depth of children should be deleted.</param>

        Public Function Delete(ByRef objInfo As Orders, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean) _
         Implements IOrdersFactory.Delete
            Try

                CheckPrimaryKeyValues(objInfo)
                Prepare(STD_DELETE_SQL, USE_STORE_PROC)

                If (nDepth <> 0) Then
                    Dim _OrderDetailsFactory As OrderDetailsFactory = New OrderDetailsFactory(getConnection())
                    _OrderDetailsFactory.DeleteByOrders(objInfo.OrderID)
                End If

                AddCmdParameter("@OrderID", TDevFramework.EDataType.eInt, objInfo.OrderID, TDevFramework.EParamDirection.eInput, objInfo.IsNull("OrderID"))
                ExecuteNonQuery()
                Stats.WriteTripsToDB = 1

                SetStatus(EStatus.eSuccess)
                ReleaseCommand()

                If bCacheEnable Then
                    DeleteCustomerCache(objInfo)

                    Dim objKey As String

                    objKey = NCacheUtil.GetObjectKey(_stObjectName, objInfo.OrderID.ToString())
                    NCacheUtil.Remove(objKey)
                    Invalidate(NCacheUtil.InvalidateType.QueryCollection, Nothing) ' Invalidating Collection With NO PK and PK	
                End If

            Catch e As Exception
                SetStatus(EStatus.eFail)
                ReleaseCommand()
                Throw e
            End Try
        End Function


        ' <summary>
        ' 	Update (Standard Update Method)
        ' </summary>
        ' <remarks>
        ' 	Updates the record in <c>[Orders]</c> table given
        ' by its primary key.
        ' </remarks>
        ' <param name="objInfo">The <c>Orders</c> info object used to update the record.</param>
        ' <param name="nDepth">Specifies depth of children should be updated.</param>

        Public Function Update(ByRef objInfo As Orders, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean) _
         Implements IOrdersFactory.Update
            Try

                CheckPrimaryKeyValues(objInfo)
                objInfo.ValidateRequiredFields()
                Prepare(STD_UPDATE_SQL, USE_STORE_PROC)
                If (nDepth <> 0) Then
                End If
                ReadPersistentObject(objInfo)
                AddCmdParameter("@OrderID", TDevFramework.EDataType.eInt, objInfo.OrderID, TDevFramework.EParamDirection.eInput, objInfo.IsNull("OrderID"))

                ExecuteNonQuery()
                Stats.WriteTripsToDB = 1

                If (nDepth <> 0) Then
                    Dim _OrderDetailsFactory As OrderDetailsFactory = New OrderDetailsFactory(getConnection())
                    _OrderDetailsFactory.Save(objInfo.OrderDetails, nDepth, bCacheEnable, New Orders)
                End If

                SetStatus(EStatus.eSuccess)
                ReleaseCommand()
                objInfo.Dirty = False

                If bCacheEnable Then
                    UpdateCustomerCache(objInfo)

                    Dim objKey As String

                    objKey = NCacheUtil.GetObjectKey(_stObjectName, objInfo.OrderID.ToString())
                    ' Updating the copy of this object in Cache.. 
                    NCacheUtil.Insert(objKey, objInfo, Nothing, DateTime.Now.AddMinutes(30))
                    Invalidate(NCacheUtil.InvalidateType.QueryCollectionPK Or NCacheUtil.InvalidateType.QueryCollection, Nothing) ' Invalidating Collection With NO PK and PK
                End If
            Catch e As Exception
                SetStatus(EStatus.eFail)
                ReleaseCommand()
                Throw e
            End Try
        End Function

#End Region
        

        Private Function Save(ByRef objList As OrdersCollection, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean, ByVal strCacheKey As String)

            Dim objInfo As Orders = Nothing
            Dim count As Integer
            Dim customerId As String
            Dim cacheKeys As ArrayList = New ArrayList
            Dim remKeys(objList.MarkedDeletedItems.Count - 1) As String
            Dim bFlag As Boolean = False

            For count = 0 To objList.MarkedDeletedItems.Count - 1
                objInfo = CType(objList.MarkedDeletedItems(count), Orders)
                Me.Delete(objInfo, nDepth, bCacheEnable)
                remKeys(count) = NCacheUtil.GetObjectKey(_stObjectName, objInfo.OrderID.ToString())
            Next count

            For count = 0 To objList.Count - 1
                objInfo = objList(count)
                customerId = objInfo.CustomerID
                If (objInfo.IsNew) Then
                    Me._Insert(objInfo, nDepth, bCacheEnable)
                    If bCacheEnable Then
                        Stats.WriteTripsToDBWithCache = 1
                        Stats.ObjsWrittenToDBWithCache = 1
                        bFlag = True
                    Else
                        Stats.WriteTripsToDB = 1
                        Stats.ObjsWrittenToDB = 1
                    End If
                ElseIf (objInfo.Dirty) Then
                    Me.Update(objInfo, nDepth, bCacheEnable)
                    If bCacheEnable Then
                        Stats.WriteTripsToDBWithCache = 1
                        Stats.ObjsWrittenToDBWithCache = 1
                        bFlag = True
                    Else
                        Stats.WriteTripsToDB = 1
                        Stats.ObjsWrittenToDB = 1
                    End If

                End If

                If bCacheEnable Then
                    Dim objKey As String
                    objKey = NCacheUtil.GetObjectKey(_stObjectName, objInfo.OrderID.ToString())
                    cacheKeys.Add(objKey)

                End If

            Next count

            If bFlag Then
                cacheKeys.Add(GetRelatedKey())
                NCacheUtil.Insert(strCacheKey, objList, cacheKeys, DateTime.Now.AddMinutes(30))
                NCacheUtil.Remove(remKeys)
            End If

        End Function

        Public Function Save(ByRef objList As OrdersCollection, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean, ByVal objParent As Customers)

            Dim strCacheKey As String

            If objList.Count = 0 Then Exit Function

            strCacheKey = NCacheUtil.GetRelationKey("Customers", "Orders", objList(0).CustomerID.ToString())
            Me.Save(objList, nDepth, bCacheEnable, strCacheKey)

        End Function


        ' <summary>
        ' 	DeleteColl (Standard Collection Delete Method)
        ' </summary>
        ' <remarks>
        ' 	Performs standard delete on a collection of <c>Orders</c> objects.
        ' </remarks>
        ' <param name="objList">The <c>OrdersCollection</c> object.</param>
        ' <param name="nDepth">integer that is passed to each delete operation.</param>		

        Public Function DeleteColl(ByRef objList As OrdersCollection, ByVal nDepth As Int32) _
                  Implements IOrdersFactory.DeleteColl

            Dim objInfo As Orders = Nothing
            Dim count As Integer

            For count = 0 To objList.Count - 1
                objInfo = objList(count)
                If (Not objInfo.IsNew) Then
                    Me.Delete(objInfo, nDepth, True)
                End If
            Next count

            For count = 0 To objList.MarkedDeletedItems.Count - 1
                objInfo = CType(objList.MarkedDeletedItems(count), Orders)
                Me.Delete(objInfo, nDepth, True)
            Next count

        End Function



#Region " Queries "

        ' <summary>
        ' 	FindByCustomers (Query Method)
        ' </summary>
        ' <remarks>
        ' 	
        ' </remarks>
        ' <returns><c>OrdersCollection</c> object containing all the records 
        '	returned in the resultset.</returns>

        Public Function FindByCustomers(ByVal strprmCustomerID As String, ByVal bCacheEnable As Boolean) As OrdersCollection _
         Implements IOrdersFactory.FindByCustomers

            Dim objKey As String
            Dim cacheKeys As ArrayList = New ArrayList
            Dim obj As Object

            objKey = NCacheUtil.GetRelationKey("Customers", "Orders", strprmCustomerID.ToString())

            If bCacheEnable Then
                obj = NCacheUtil.Load(objKey) ' Try to load from Cache...
                If Not obj Is Nothing Then
                    Stats.ObjsReadFromCache = CType(obj, OrdersCollection).Count
                    Return CType(obj, OrdersCollection) ' Return from Cache..
                End If
            End If

            Dim objInfo As Orders
            Dim objList As OrdersCollection = New OrdersCollection

            Try

                Prepare(FindByCustomers_SQL, USE_STORE_PROC)

                AddCmdParameter("@prmCustomerID", TDevFramework.EDataType.eVarchar, strprmCustomerID, EParamDirection.eInput)
                ExecuteReader()
                While (Read())
                    objInfo = New Orders
                    If (Not IsNull("OrderID")) Then
                        objInfo.OrderID = Convert.ToInt32(getValue("OrderID"))
                    End If
                    If (Not IsNull("CustomerID")) Then
                        objInfo.CustomerID = Convert.ToString(getValue("CustomerID"))
                    End If
                    If (Not IsNull("EmployeeID")) Then
                        objInfo.EmployeeID = Convert.ToInt32(getValue("EmployeeID"))
                    End If
                    If (Not IsNull("OrderDate")) Then
                        objInfo.OrderDate = Convert.ToDateTime(getValue("OrderDate"))
                    End If
                    If (Not IsNull("RequiredDate")) Then
                        objInfo.RequiredDate = Convert.ToDateTime(getValue("RequiredDate"))
                    End If
                    If (Not IsNull("ShippedDate")) Then
                        objInfo.ShippedDate = Convert.ToDateTime(getValue("ShippedDate"))
                    End If
                    If (Not IsNull("ShipVia")) Then
                        objInfo.ShipVia = Convert.ToInt32(getValue("ShipVia"))
                    End If
                    If (Not IsNull("Freight")) Then
                        objInfo.Freight = Convert.ToDecimal(getValue("Freight"))
                    End If
                    If (Not IsNull("ShipName")) Then
                        objInfo.ShipName = Convert.ToString(getValue("ShipName"))
                    End If
                    If (Not IsNull("ShipAddress")) Then
                        objInfo.ShipAddress = Convert.ToString(getValue("ShipAddress"))
                    End If
                    If (Not IsNull("ShipCity")) Then
                        objInfo.ShipCity = Convert.ToString(getValue("ShipCity"))
                    End If
                    If (Not IsNull("ShipRegion")) Then
                        objInfo.ShipRegion = Convert.ToString(getValue("ShipRegion"))
                    End If
                    If (Not IsNull("ShipPostalCode")) Then
                        objInfo.ShipPostalCode = Convert.ToString(getValue("ShipPostalCode"))
                    End If
                    If (Not IsNull("ShipCountry")) Then
                        objInfo.ShipCountry = Convert.ToString(getValue("ShipCountry"))
                    End If
                    objInfo.IsNew = False
                    objInfo.Dirty = False
                    objList.Add(objInfo)
                    Stats.ObjsReadFromDB = 1

                    If bCacheEnable Then
                        Stats.ObjsReadFromDBWithCache = 1
                        Stats.ReadTripsToDBWithCache = 1

                        Dim key As String
                        key = NCacheUtil.GetObjectKey(_stObjectName, objInfo.OrderID.ToString())
                        cacheKeys.Add(key)
                        NCacheUtil.Store(key, objInfo, Nothing, DateTime.Now.AddMinutes(30))

                    End If
                End While


                ReleaseReader()
                SetStatus(EStatus.eSuccess)
                ReleaseCommand()
                Stats.ReadTripsToDB = 1
                If bCacheEnable Then
                    Stats.ReadTripsToDBWithCache = 1
                    If cacheKeys.Count > 0 Then
                        cacheKeys.Add(GetRelatedKey())
                        NCacheUtil.Store(objKey, objList, cacheKeys, DateTime.Now.AddMinutes(30))
                    End If


                End If


            Catch e As Exception
                SetStatus(EStatus.eFail)
                ReleaseCommand()
                Throw e
            End Try
            Return objList
        End Function


        ' <summary>
        ' 	FindByCustomersCount (Query Method)
        ' </summary>
        ' <remarks>
        ' 	This method executes the query and returns the number of records returned in the resultset.
        ' 	See Also: <seealso cref="FindByCustomers"/>. 
        ' </remarks>
        ' <returns>Number of records returned in the resultset.</returns>		

        Public Function FindByCustomersCount(ByVal strprmCustomerID As String) As Int32 _
          Implements IOrdersFactory.FindByCustomersCount

            Dim recordCount As Int32 = 0
            Try

                Prepare(FindByCustomersCount_SQL, False)
                AddCmdParameter("@prmCustomerID", TDevFramework.EDataType.eVarchar, strprmCustomerID, EParamDirection.eInput)
                recordCount = CType(ExecuteScalar(), Int32)
                SetStatus(EStatus.eSuccess)
                ReleaseCommand()
            Catch e As Exception
                SetStatus(EStatus.eFail)
                ReleaseCommand()
                Throw e
            End Try
            Return recordCount
        End Function


        ' <summary>
        ' 	FindByCustomersPR (Query Method)
        ' </summary>
        ' <remarks>
        ' 	This method executes the query and returns the number of records returned in the resultset.
        ' 	See Also: <seealso cref="FindByCustomers"/>. 
        ' </remarks>
        ' <returns><c>OrdersCollection</c> object containing the specified number of records 
        '	starting from index '<c>nSP</c>' in the resultset.</returns>		

        Public Function FindByCustomersPR(ByVal nSP As Int32, ByVal nRecords As Int32, ByVal strprmCustomerID As String) As OrdersCollection _
         Implements IOrdersFactory.FindByCustomersPR

            Dim count As Integer = 0
            Dim objInfo As Orders
            Dim objList As OrdersCollection = New OrdersCollection

            Try
                nSP -= 1
                If (nSP < 0) Then
                    nSP = 0
                End If

                Prepare(FindByCustomers_SQL, USE_STORE_PROC)

                AddCmdParameter("@prmCustomerID", TDevFramework.EDataType.eVarchar, strprmCustomerID, EParamDirection.eInput)
                ExecuteReader()
                While (Read())
                    If (count > (nRecords + nSP)) Then
                        Exit While
                    End If
                    If ((count >= nSP) And (count < (nRecords + nSP))) Then
                        objInfo = New Orders
                        If (Not IsNull("OrderID")) Then
                            objInfo.OrderID = Convert.ToInt32(getValue("OrderID"))
                        End If
                        If (Not IsNull("CustomerID")) Then
                            objInfo.CustomerID = Convert.ToString(getValue("CustomerID"))
                        End If
                        If (Not IsNull("EmployeeID")) Then
                            objInfo.EmployeeID = Convert.ToInt32(getValue("EmployeeID"))
                        End If
                        If (Not IsNull("OrderDate")) Then
                            objInfo.OrderDate = Convert.ToDateTime(getValue("OrderDate"))
                        End If
                        If (Not IsNull("RequiredDate")) Then
                            objInfo.RequiredDate = Convert.ToDateTime(getValue("RequiredDate"))
                        End If
                        If (Not IsNull("ShippedDate")) Then
                            objInfo.ShippedDate = Convert.ToDateTime(getValue("ShippedDate"))
                        End If
                        If (Not IsNull("ShipVia")) Then
                            objInfo.ShipVia = Convert.ToInt32(getValue("ShipVia"))
                        End If
                        If (Not IsNull("Freight")) Then
                            objInfo.Freight = Convert.ToDecimal(getValue("Freight"))
                        End If
                        If (Not IsNull("ShipName")) Then
                            objInfo.ShipName = Convert.ToString(getValue("ShipName"))
                        End If
                        If (Not IsNull("ShipAddress")) Then
                            objInfo.ShipAddress = Convert.ToString(getValue("ShipAddress"))
                        End If
                        If (Not IsNull("ShipCity")) Then
                            objInfo.ShipCity = Convert.ToString(getValue("ShipCity"))
                        End If
                        If (Not IsNull("ShipRegion")) Then
                            objInfo.ShipRegion = Convert.ToString(getValue("ShipRegion"))
                        End If
                        If (Not IsNull("ShipPostalCode")) Then
                            objInfo.ShipPostalCode = Convert.ToString(getValue("ShipPostalCode"))
                        End If
                        If (Not IsNull("ShipCountry")) Then
                            objInfo.ShipCountry = Convert.ToString(getValue("ShipCountry"))
                        End If
                        objInfo.IsNew = False
                        objInfo.Dirty = False
                        objList.Add(objInfo)
                    End If
                    count += 1
                End While


                If (count = 0) Then
                    Throw New Exception("No record found against this criteria")
                ElseIf (Not (count = 0)) Then
                    nSP += 1
                    If (nSP > count) Then
                        Dim strMsg As String = "There are " + count.ToString() + " records in the table. "
                        strMsg = strMsg + "Hence the given staring index is invalid."
                        Throw New Exception(strMsg)
                    ElseIf (nRecords > count) Then
                        Dim strMsg As String = "There are " + count.ToString() + " records in the table. "
                        strMsg = strMsg + "Hence the given parameter for records to display is out of range."
                        Throw New Exception(strMsg)
                    ElseIf ((nRecords + nSP - 1) > count) Then
                        Dim strMsg As String = "There are " + count.ToString() + " records in the table. "
                        strMsg = strMsg + "Hence the given parameters are out of range."
                        Throw New Exception(strMsg)
                    End If

                End If

                SetStatus(EStatus.eSuccess)
                ReleaseCommand()
            Catch e As Exception
                SetStatus(EStatus.eFail)
                ReleaseCommand()
                Throw e
            End Try
            Return objList
        End Function



        ' <summary>
        ' 	getCustomerOrders (Query Method)
        ' </summary>
        ' <remarks>
        ' 	
        ' </remarks>
        ' <returns><c>OrdersCollection</c> object containing all the records 
        '	returned in the resultset.</returns>

        Public Function getCustomerOrders(ByVal strprm1 As String, ByVal bCacheEnable As Boolean) As OrdersCollection _
         Implements IOrdersFactory.getCustomerOrders

            Dim objKey As String
            Dim cacheKeys As ArrayList = New ArrayList
            Dim obj As Object

            objKey = NCacheUtil.GetQueryKey("Orders", "getCustomerOrders", strprm1.ToString())

            If bCacheEnable Then
                obj = NCacheUtil.Load(objKey) ' Try to load from Cache...
                If Not obj Is Nothing Then
                    Stats.ObjsReadFromCache = CType(obj, OrdersCollection).Count
                    Return CType(obj, OrdersCollection) ' Return from Cache..
                End If
            End If

            Dim objInfo As Orders
            Dim objList As OrdersCollection = New OrdersCollection

            Try

                Prepare(getCustomerOrders_SQL, USE_STORE_PROC)

                AddCmdParameter("@prm1", TDevFramework.EDataType.eVarchar, strprm1, EParamDirection.eInput)
                ExecuteReader()

                While (Read())
                    objInfo = New Orders
                    If (Not IsNull("OrderID")) Then
                        objInfo.OrderID = Convert.ToInt32(getValue("OrderID"))
                    End If
                    If (Not IsNull("CustomerID")) Then
                        objInfo.CustomerID = Convert.ToString(getValue("CustomerID"))
                    End If
                    If (Not IsNull("EmployeeID")) Then
                        objInfo.EmployeeID = Convert.ToInt32(getValue("EmployeeID"))
                    End If
                    If (Not IsNull("OrderDate")) Then
                        objInfo.OrderDate = Convert.ToDateTime(getValue("OrderDate"))
                    End If
                    If (Not IsNull("RequiredDate")) Then
                        objInfo.RequiredDate = Convert.ToDateTime(getValue("RequiredDate"))
                    End If
                    If (Not IsNull("ShippedDate")) Then
                        objInfo.ShippedDate = Convert.ToDateTime(getValue("ShippedDate"))
                    End If
                    If (Not IsNull("ShipVia")) Then
                        objInfo.ShipVia = Convert.ToInt32(getValue("ShipVia"))
                    End If
                    If (Not IsNull("Freight")) Then
                        objInfo.Freight = Convert.ToDecimal(getValue("Freight"))
                    End If
                    If (Not IsNull("ShipName")) Then
                        objInfo.ShipName = Convert.ToString(getValue("ShipName"))
                    End If
                    If (Not IsNull("ShipAddress")) Then
                        objInfo.ShipAddress = Convert.ToString(getValue("ShipAddress"))
                    End If
                    If (Not IsNull("ShipCity")) Then
                        objInfo.ShipCity = Convert.ToString(getValue("ShipCity"))
                    End If
                    If (Not IsNull("ShipRegion")) Then
                        objInfo.ShipRegion = Convert.ToString(getValue("ShipRegion"))
                    End If
                    If (Not IsNull("ShipPostalCode")) Then
                        objInfo.ShipPostalCode = Convert.ToString(getValue("ShipPostalCode"))
                    End If
                    If (Not IsNull("ShipCountry")) Then
                        objInfo.ShipCountry = Convert.ToString(getValue("ShipCountry"))
                    End If
                    objInfo.IsNew = False
                    objInfo.Dirty = False
                    objList.Add(objInfo)
                    Stats.ObjsReadFromDB = 1
                    If bCacheEnable Then
                        Stats.ObjsReadFromDBWithCache = 1
                        Dim key As String
                        key = NCacheUtil.GetObjectKey(_stObjectName, objInfo.OrderID.ToString())
                        cacheKeys.Add(key)
                        NCacheUtil.Store(key, objInfo, Nothing, DateTime.Now.AddMinutes(30))
                    End If


                End While


                ReleaseReader()
                SetStatus(EStatus.eSuccess)
                ReleaseCommand()
                Stats.ReadTripsToDB = 1
                If bCacheEnable Then
                    Stats.ReadTripsToDBWithCache = 1

                    If cacheKeys.Count > 0 Then
                        cacheKeys.Add(GetPKQueryKey())
                        NCacheUtil.Store(objKey, objList, cacheKeys, DateTime.Now.AddMinutes(30))
                    End If

                End If

            Catch e As Exception
                SetStatus(EStatus.eFail)
                ReleaseCommand()
                Throw e
            End Try
            Return objList
        End Function


        ' <summary>
        ' 	getCustomerOrdersCount (Query Method)
        ' </summary>
        ' <remarks>
        ' 	This method executes the query and returns the number of records returned in the resultset.
        ' 	See Also: <seealso cref="getCustomerOrders"/>. 
        ' </remarks>
        ' <returns>Number of records returned in the resultset.</returns>		

        Public Function getCustomerOrdersCount(ByVal strprm1 As String) As Int32 _
          Implements IOrdersFactory.getCustomerOrdersCount

            Dim recordCount As Int32 = 0
            Try

                Prepare(getCustomerOrdersCount_SQL, False)
                AddCmdParameter("@prm1", TDevFramework.EDataType.eVarchar, strprm1, EParamDirection.eInput)
                recordCount = CType(ExecuteScalar(), Int32)
                SetStatus(EStatus.eSuccess)
                ReleaseCommand()
            Catch e As Exception
                SetStatus(EStatus.eFail)
                ReleaseCommand()
                Throw e
            End Try
            Return recordCount
        End Function




#End Region

#Region " Bulk Update Operations "

#End Region

#Region " Bulk Delete Operations "

        ' <summary>
        ' 	DeleteByCustomers (Bulk Delete Method)
        ' </summary>
        ' <remarks>
        ' 	<para>Deletes all the record in <c>[Orders]</c> table matching the given criteria.</para>
        ' 	<para>
        ' 	
        ' 	</para>
        ' </remarks>
        ' <returns>The number of rows affected.</returns>	

        Public Function DeleteByCustomers(ByVal strprmCustomerID As String) As Integer _
                  Implements IOrdersFactory.DeleteByCustomers

            Dim result As Integer = 0
            Try
                Prepare(DeleteByCustomers_SQL, USE_STORE_PROC)

                AddCmdParameter("@prmCustomerID", TDevFramework.EDataType.eVarchar, strprmCustomerID, EParamDirection.eInput)
                result = ExecuteNonQuery()


                SetStatus(EStatus.eSuccess)
                ReleaseCommand()

                Dim cachekey(1) As String
                cachekey(0) = NCacheUtil.GetRelationKey("Customers", "Orders", strprmCustomerID.ToString())
                Invalidate(NCacheUtil.InvalidateType.All, cachekey)
            Catch e As Exception
                SetStatus(EStatus.eFail)
                ReleaseCommand()
                Throw e
            End Try
            Return result
        End Function

#End Region

#Region " Custom Insert Operations "

#End Region

#Region " Custom Update Operations "

#End Region

#Region " Custom Load Operations "

#End Region

#Region " Stored Procedures "

#End Region

#Region " Utility Methods "

        Private Function FillPersistentObject(ByVal objInfo As Orders)

            If (Not IsNull("OrderID")) Then
                objInfo.OrderID = Convert.ToInt32(getValue("OrderID"))
            End If
            If (Not IsNull("CustomerID")) Then
                objInfo.CustomerID = Convert.ToString(getValue("CustomerID"))
            End If
            If (Not IsNull("EmployeeID")) Then
                objInfo.EmployeeID = Convert.ToInt32(getValue("EmployeeID"))
            End If
            If (Not IsNull("OrderDate")) Then
                objInfo.OrderDate = Convert.ToDateTime(getValue("OrderDate"))
            End If
            If (Not IsNull("RequiredDate")) Then
                objInfo.RequiredDate = Convert.ToDateTime(getValue("RequiredDate"))
            End If
            If (Not IsNull("ShippedDate")) Then
                objInfo.ShippedDate = Convert.ToDateTime(getValue("ShippedDate"))
            End If
            If (Not IsNull("ShipVia")) Then
                objInfo.ShipVia = Convert.ToInt32(getValue("ShipVia"))
            End If
            If (Not IsNull("Freight")) Then
                objInfo.Freight = Convert.ToDecimal(getValue("Freight"))
            End If
            If (Not IsNull("ShipName")) Then
                objInfo.ShipName = Convert.ToString(getValue("ShipName"))
            End If
            If (Not IsNull("ShipAddress")) Then
                objInfo.ShipAddress = Convert.ToString(getValue("ShipAddress"))
            End If
            If (Not IsNull("ShipCity")) Then
                objInfo.ShipCity = Convert.ToString(getValue("ShipCity"))
            End If
            If (Not IsNull("ShipRegion")) Then
                objInfo.ShipRegion = Convert.ToString(getValue("ShipRegion"))
            End If
            If (Not IsNull("ShipPostalCode")) Then
                objInfo.ShipPostalCode = Convert.ToString(getValue("ShipPostalCode"))
            End If
            If (Not IsNull("ShipCountry")) Then
                objInfo.ShipCountry = Convert.ToString(getValue("ShipCountry"))
            End If

        End Function

        Private Function ReadPersistentObject(ByVal objInfo As Orders)

            AddCmdParameter("@CustomerID", TDevFramework.EDataType.eVarchar, objInfo.CustomerID, TDevFramework.EParamDirection.eInput, objInfo.IsNull("CustomerID"))
            AddCmdParameter("@EmployeeID", TDevFramework.EDataType.eInt, objInfo.EmployeeID, TDevFramework.EParamDirection.eInput, objInfo.IsNull("EmployeeID"))
            AddCmdParameter("@OrderDate", TDevFramework.EDataType.eDateTime, objInfo.OrderDate, TDevFramework.EParamDirection.eInput, objInfo.IsNull("OrderDate"))
            AddCmdParameter("@RequiredDate", TDevFramework.EDataType.eDateTime, objInfo.RequiredDate, TDevFramework.EParamDirection.eInput, objInfo.IsNull("RequiredDate"))
            AddCmdParameter("@ShippedDate", TDevFramework.EDataType.eDateTime, objInfo.ShippedDate, TDevFramework.EParamDirection.eInput, objInfo.IsNull("ShippedDate"))
            AddCmdParameter("@ShipVia", TDevFramework.EDataType.eInt, objInfo.ShipVia, TDevFramework.EParamDirection.eInput, objInfo.IsNull("ShipVia"))
            AddCmdParameter("@Freight", TDevFramework.EDataType.eDecimal, objInfo.Freight, TDevFramework.EParamDirection.eInput, objInfo.IsNull("Freight"))
            AddCmdParameter("@ShipName", TDevFramework.EDataType.eVarchar, objInfo.ShipName, TDevFramework.EParamDirection.eInput, objInfo.IsNull("ShipName"))
            AddCmdParameter("@ShipAddress", TDevFramework.EDataType.eVarchar, objInfo.ShipAddress, TDevFramework.EParamDirection.eInput, objInfo.IsNull("ShipAddress"))
            AddCmdParameter("@ShipCity", TDevFramework.EDataType.eVarchar, objInfo.ShipCity, TDevFramework.EParamDirection.eInput, objInfo.IsNull("ShipCity"))
            AddCmdParameter("@ShipRegion", TDevFramework.EDataType.eVarchar, objInfo.ShipRegion, TDevFramework.EParamDirection.eInput, objInfo.IsNull("ShipRegion"))
            AddCmdParameter("@ShipPostalCode", TDevFramework.EDataType.eVarchar, objInfo.ShipPostalCode, TDevFramework.EParamDirection.eInput, objInfo.IsNull("ShipPostalCode"))
            AddCmdParameter("@ShipCountry", TDevFramework.EDataType.eVarchar, objInfo.ShipCountry, TDevFramework.EParamDirection.eInput, objInfo.IsNull("ShipCountry"))

        End Function


        Private Function CheckPrimaryKeyValues(ByVal objInfo As Orders) As Boolean
            If ((objInfo("OrderID").Null)) Then
                Throw New Exception("Primary key must have some valid value.")
            End If
            Return True

        End Function

#End Region

#Region "LoadChildren Methods"

        Public Function LoadChildren(ByRef objInfo As Orders, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean)
            LoadOrderDetails(objInfo, nDepth, bCacheEnable)
        End Function


        Public Function LoadOrderDetails(ByRef objInfo As Orders, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean)
            Try

                Dim _OrderDetailsFactory As OrderDetailsFactory = New OrderDetailsFactory(getConnection())
                objInfo.OrderDetails = _OrderDetailsFactory.FindByOrders(objInfo.OrderID, bCacheEnable)
                If (nDepth <> 0) Then
                    Dim OrderDetailsOrderDetailsInfo As OrderDetails
                    For Each OrderDetailsOrderDetailsInfo In objInfo.OrderDetails
                        _OrderDetailsFactory.LoadChildren(OrderDetailsOrderDetailsInfo, nDepth - 1, bCacheEnable)
                    Next
                End If
                SetStatus(EStatus.eSuccess)

            Catch e As RecordNotFoundException
                SetStatus(EStatus.eFail)
                'ignore exception
            Catch e As Exception
                SetStatus(EStatus.eFail)
                Throw e
            End Try
        End Function

#End Region

    End Class
End Namespace
